<?php
/**
 *
 * @category        snippets
 * @package         socialBaker
 * @author          Ruud Eisinga - http://www.dev4me.nl/modules-snippets/opensource/socialbaker/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @version         1.2
 * @lastmodified    Date: 2015-01-05
 *
 */
/* -------------------------------------------------------- */

// Must include code to stop this file being access directly
if(defined('WB_PATH') == false) { die("Cannot access this file directly"); }

global $socialDefaults, $followDefaults;




$socialDefaults['twitter'] = array (
		'id' 		=> 1,
		'name' 		=> 'Twitter',
		'share' 	=> 'https://twitter.com/intent/tweet?url={URL}&text={STATUS} - {DESCRIPTION}',
		'icon' 		=> 'twitter.png'
	);
$socialDefaults['facebook'] = array (
		'id' 		=> 2,
		'name' 		=> 'Facebook',
		'share' 	=> 'https://www.facebook.com/sharer/sharer.php?u={URL}',
		'icon' 		=> 'facebook.png'
	);
$socialDefaults['googleplus'] = array (
		'id' 		=> 3,
		'name' 		=> 'GooglePlus',
		'share' 	=> 'https://plus.google.com/share?url={URL}',
		'icon' 		=> 'googleplus.png'
	);
$socialDefaults['linkedin'] = array (
		'id' 		=> 4,
		'name' 		=> 'LinkedIn',
		'share' 	=> 'https://www.linkedin.com/shareArticle?mini=true&url={URL}&title={STATUS}&summary={DESCRIPTION}&source=',
		'icon' 		=> 'linkedin.png'
	);

$socialDefaults['digg'] = array (
		'id' 		=> 5,
		'name' 		=> 'Digg',
		'share' 	=> 'http://www.digg.com/submit?url={URL}&title={STATUS}',
		'icon' 		=> 'digg.png'
	);
	
$socialDefaults['stumbleupon'] = array (
		'id' 		=> 6,
		'name' 		=> 'StumbleUpon',
		'share' 	=> 'http://www.stumbleupon.com/submit?url={URL}&title={STATUS}',
		'icon' 		=> 'stumbleupon.png'
	);
	
$socialDefaults['delicious'] = array (
		'id' 		=> 7,
		'name' 		=> 'Delicious',
		'share' 	=> 'https://delicious.com/save?v=5&noui&jump=close&url={URL}&title={STATUS}',
		'icon' 		=> 'delicious.png'
	);
$socialDefaults['vk'] = array (
		'id' 		=> 8,
		'name' 		=> 'VKontakte',
		'share' 	=> 'http://vk.com/share.php?url={URL}&title={STATUS}',
		'icon' 		=> 'vk.png'
	);
$socialDefaults['reddit'] = array (
		'id' 		=> 9,
		'name' 		=> 'Reddit',
		'share' 	=> 'http://www.reddit.com/submit?url={URL}&title={STATUS}',
		'icon' 		=> 'reddit.png'
	);
$socialDefaults['tumblr'] = array (
		'id' 		=> 10,
		'name' 		=> 'Tumblr',
		'share' 	=> 'http://www.tumblr.com/share?v=3&u={URL}&t={STATUS}',
		'icon' 		=> 'tumblr.png'
	);
	
	


function socialBaker($status = null, $imagePath = null, $shares = null) {
	global $socialDefaults, $wb;
	$url = 'http'.($_SERVER['SERVER_PORT'] == 443 ? 's' : '') . '://'.$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
	$description = $wb->page_description;
	$image = '';
	if(!$status) $status = page_status(); 			// if no status (message) is set use Pagetitle
	if(is_array($status)) {
		if(isset($status['url'])) $url = $status['url'];
		if(isset($status['image'])) $image = $status['image'];
		if(isset($status['description'])) $description = $status['description'];
		if(isset($status['status'])) $status = $status['status']; else $status = PAGE_TITLE;
	}
	if(!$imagePath) $imagePath = WB_URL.'/modules/socialbaker/images/'; // if imagePath is not set, use internal icons
	
	if(!$shares) $shares = $socialDefaults; 	// if shares are not set, use all..
	if(!is_array($shares)) $shares = explode(",",$shares);
			
	$retval = '<div class="socialwrapper">';
	foreach ( $shares as $share ) {
		if(!is_array($share)) { 				//element is just a string or number.. find default values..
			if (is_numeric($share)) {
				foreach ($socialDefaults as $tmp) {
					if($tmp['id'] == $share) {
						$share = $tmp;
						break;
					}
				}
			} elseif(is_string($share)) { 			//element is string, just use it as index of the defaults array
				if(isset($socialDefaults[strtolower($share)])) {
					$share = $socialDefaults[strtolower($share)];
				}
			} 
		}
		if(is_array($share)) {
			$share['share'] = str_ireplace('{URL}',urlencode($url),$share['share']);
			$share['share'] = str_ireplace('{IMAGE}',urlencode($image),$share['share']);
			$share['share'] = str_ireplace('{DESCRIPTION}',urlencode($description),$share['share']);
			$share['share'] = str_ireplace('{STATUS}',urlencode($status),$share['share']);
			$retval .= '<div class="socialbaker"><a class="share '.strtolower($share['name']).'" title="'.$share['name'].'" href="'.$share['share'].'"><img class="shareicon" src="'.$imagePath.$share['icon'].'" alt="'.$share['name'].'" /></a></div>'.PHP_EOL;
		}
	}
	$retval .= '</div>';
	return $retval;
}



// FollowBaker

$followDefaults['twitter'] = array (
	'title' 	=> 'Follow us on Twitter',
	'link' 		=> 'https://twitter.com/{ACCOUNT}',
	'icon' 		=> 'twitter.png'
);
$followDefaults['facebook'] = array (
	'title' 	=> 'Follow us on Facebook',
	'link' 		=> 'https://www.facebook.com/{ACCOUNT}',
	'icon' 		=> 'facebook.png'
);
$followDefaults['googleplus'] = array (
	'title' 	=> 'Follow us on Google',
	'link' 		=> 'https://plus.google.com/{ACCOUNT}',
	'icon' 		=> 'googleplus.png'
);
$followDefaults['linkedin'] = array (
	'title' 	=> 'LinkedIn',
	'link' 		=> 'https://linkedin.com/in/{ACCOUNT}',
	'icon' 		=> 'linkedin.png'
);

$followDefaults['vk'] = array (
	'title' 	=> 'Follow us on VK',
	'link' 		=> 'https://www.vk.com/{ACCOUNT}',
	'icon' 		=> 'vk.png'
);


$followDefaults['youtube'] = array (
	'title' 	=> 'YouTube',
	'link' 		=> 'http://youtube.com/user/{ACCOUNT}',
	'icon' 		=> 'youtube.png'
);

$followDefaults['vimeo'] = array (
	'title' 	=> 'Vimeo',
	'link' 		=> 'http://vimeo.com/{ACCOUNT}',
	'icon' 		=> 'vimeo.png'
);

$followDefaults['instagram'] = array (
	'title' 	=> 'Instagram',
	'link' 		=> 'http://instagram.com/{ACCOUNT}',
	'icon' 		=> 'instagram.png'
);

$followDefaults['pinterest'] = array (
	'title' 	=> 'Pinterest',
	'link' 		=> 'http://pinterest.com/{ACCOUNT}',
	'icon' 		=> 'pinterest.png'
);

$followDefaults['flickr'] = array (
	'title' 	=> 'Flickr',
	'link' 		=> 'http://flickr.com/photos/{ACCOUNT}',
	'icon' 		=> 'flickr.png'
);





function followBaker($follows = null, $imagePath = null) {
	global $followDefaults;
	if(!$imagePath) $imagePath = WB_URL.'/modules/socialbaker/images/'; // if imagePath is not set, use internal icons
	$retval = '<div class="followwrapper">';
	foreach ( $follows as $follow => $account ) {
		if($data = $followDefaults[$follow]) {
			$data['link'] = str_ireplace('{ACCOUNT}',$account , $data['link']);
			$retval .= '<div class="followbaker"><a target="_blank" class="follow '.strtolower($follow).'" title="'.$data['title'].'" href="'.$data['link'].'"><img class="followicon" src="'.$imagePath.$data['icon'].'" alt="'.$data['title'].'" /></a></div>'.PHP_EOL;
		}
	}
	$retval .= '</div>';
	return $retval;
}

function shareBaker($shares = null) {
	return socialBaker(null,null,$shares);
}

function page_status() {
	global $database,$post_id,$item_id;
	if(isset($post_id )) {
		$title = $database->get_one("SELECT `title` from ".TABLE_PREFIX."mod_news_posts WHERE `post_id` = '$post_id'");
	} elseif (isset($item_id) || defined(ITEM_ID) ) {
		if(!isset($item_id))$item_id = ITEM_ID;
		$title = $database->get_one("SELECT `title` from ".TABLE_PREFIX."mod_bakery_items WHERE `item_id` = '$item_id'");	
	} else {
		$title = PAGE_TITLE;
	}
	return $title;
}
?>
